/*---------------------------------------------------------------------------*\
  =========                 |
  \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox
   \\    /   O peration     |
    \\  /    A nd           | Copyright (C) 2011 OpenFOAM Foundation
     \\/     M anipulation  |
-------------------------------------------------------------------------------
License
    This file is part of OpenFOAM.

    OpenFOAM is free software: you can redistribute it and/or modify it
    under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    OpenFOAM is distributed in the hope that it will be useful, but WITHOUT
    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
    for more details.

    You should have received a copy of the GNU General Public License
    along with OpenFOAM.  If not, see <http://www.gnu.org/licenses/>.

\*---------------------------------------------------------------------------*/

#include "constantDecayHeat.H"
// #include "addToRunTimeSelectionTable.H"
// 
// // * * * * * * * * * * * * * * Static Data Members * * * * * * * * * * * * * //
// 
// namespace Foam
// {
// namespace DecayHeatModels
// {
// 
//     defineTypeNameAndDebug(constant, 0);
// 
//     addToRunTimeSelectionTable
//     (
//         DecayHeatModel,
//         constant,
//         dictionary
//     );
// }
// }
// * * * * * * * * * * * * * * * * Constructors  * * * * * * * * * * * * * * //

template<class CloudType>
Foam::constantDecayHeat<CloudType>::constantDecayHeat
(
    const dictionary& dict,
    CloudType& cloud
)
:
    DecayHeatModel<CloudType>(dict, cloud, typeName),
    decayPower_(readScalar(this->coeffDict().lookup("decayPower")))
{}


template<class CloudType>
Foam::constantDecayHeat<CloudType>::constantDecayHeat
(
    const constantDecayHeat<CloudType>& dhm
)
:
    DecayHeatModel<CloudType>(dhm)
{}


// * * * * * * * * * * * * * * * * Destructor  * * * * * * * * * * * * * * * //

template<class CloudType>
Foam::constantDecayHeat<CloudType>::~constantDecayHeat()
{}


// * * * * * * * * * * * * * * * Member Functions  * * * * * * * * * * * * * //

template<class CloudType>
bool Foam::constantDecayHeat<CloudType>::active() const
{
    return false;
}

template<class CloudType>
Foam::scalar Foam::constantDecayHeat<CloudType>::decayPower() const
{
    
    return decayPower_;
    
}
// ************************************************************************* //
